#include "inkey.ch"

STATIC oConexao

PROCEDURE main()

clear
@ 10,10 say "Inicio do programa"

*wbanco = "DBF"
 wbanco = "ADO"
*wbanco = "SQLMIX"

***************************************************************************
**************************************************** ABERTURA DOS ARQUIVOS
***************************************************************************
* CADASTRO.DBF										NOME   C(20)
*														DTNASC D
* TABELA MYSQL: cadastro     					IDADE  N 2,0

@ 11,10 say "Abertura dos Arquivos..."

if wbanco = "DBF"
	*************** CLIPPER ************************
	use cadastro alias cadastro
		zap
		index on nome  to icad1
		index on idade to icad2
	   set index to icad1, icad2
	clear
   set dele on

elseif wbanco = "ADO"
	****************** ADO / HARBOUR *************** 
	* habilitar STATIC FUNCTION ConfiguraConexao()
   ConfiguraConexao()
   oConexao:Open()

elseif wbanco = "SQLMIX"
	*************** SQLMIX / HARBOUR *************** 
endif

********************* VARIAVEIS
set date brit
wnome   = "Jose"
wdtnasc = date()
widade  = 30

***************************************************************************
**************************************************** INCLUSAO
***************************************************************************
@ 12,10 say "Inclusao..."

decl wvnome[05], wvdtnasc[05], wvidade[05]
for i = 1 to 3
	wvnome[i]   = "Maria " + " " + str(i,3)
	wvdtnasc[i] = date() - 15
	wvidade[i]  = 25
next

if wbanco = "DBF"
	*************** CLIPPER ************************
	for i = 1 to 15				// cria 15 registros ...
	   sele cadastro
	       go bottom
	       append blank
	   replace nome   with wnome + " " + str(i,3)
	   replace dtnasc with wdtnasc
	   replace idade  with widade
	next
	***** gravando com vetores, mesma logica
	for i = 1 to 3
	   sele cadastro
	       go bottom
	       append blank
	   replace nome   with wvnome[i]
	   replace dtnasc with wvdtnasc[i]
	   replace idade  with wvidade[i]
	next

elseif wbanco = "ADO"
	****************** ADO / HARBOUR *************** 
   for i = 1 to 15           // cria 15 registros ...
      wsql   = "INSERT INTO cadastro ( NOME, DTNASC, IDADE ) "
      wnome1 = wnome + " " + str(i,3)
      wsql = wsql + " VALUES ( " + StringSql(wnome1) + "," + StringSql(dtoc(wdtnasc)) + "," + NumericSql(widade) + " )"
      oConexao:Execute(wsql)
   next

	*em um segundo exemplo, como gravar registros com vetores numa unica vez ?
	for i = 1 to 3
		* ?
		* wvnome[i]
		* wvdtnasc[i]
		* wvidade[i]
	next

   *como obter a confirmacao das inclusoes ? no php tem um "die" ... 

elseif wbanco = "SQLMIX"
	*************** SQLMIX / HARBOUR *************** 
	* mesmos exemplos do ADO

endif

***************************************************************************
**************************************************** ALTERACAO
***************************************************************************
@ 13,10 say "Alteracao..."

wch_alt    = "Jose  11"
wnovovalor = 50

if wbanco = "DBF"
	*************** CLIPPER *************** 
   sele cadastro
      set order to 1
		go top
   seek (wch_alt)
   if eof()
      alert ( "erro" )
   else
      replace idade  with wnovovalor
   endif

elseif wbanco = "ADO"
	****************** ADO / HARBOUR *************** 
   wsql =        "UPDATE cadastro SET "
	wsql = wsql + " IDADE = " + NumericSql(wnovovalor) 
	wsql = wsql + " WHERE NOME = " + StringSql(wch_alt)
   oConexao:Execute( wsql )

   *como obter a confirmacao da alteracao ?

elseif wbanco = "SQLMIX"
	*************** SQLMIX / HARBOUR *************** 
	* mesmos exemplos do ADO

endif


***************************************************************************
**************************************************** EXCLUSAO
***************************************************************************
@ 14,10 say "Exclusao..."

wch_exc = "Jose   7"

if wbanco = "DBF"
	*************** CLIPPER ************************
   sele cadastro
      set order to 1
		go top
   seek (wch_exc)
   if eof()
      alert ( "erro" )
   else
      delete
   endif

elseif wbanco = "ADO"
	****************** ADO / HARBOUR *************** 
   wsql = "DELETE FROM cadastro WHERE NOME = " + StringSql(wch_exc)
   oConexao:Execute( wsql )

   *como obter a confirmacao da exclusao ?

elseif wbanco = "SQLMIX"
	*************** SQLMIX / HARBOUR *************** 
	* mesmos exemplos do ADO

endif


***************************************************************************
**************************************************** CONSULTA
***************************************************************************
@ 15,10 say "Consulta..."

* tem que vir 13 registros
*                menos Jose 11 (idade diferente)
*                menos Jose  7 (excluido)

wpesq = 30

if wbanco = "DBF"
	*************** CLIPPER ************************
   sele cadastro
       set order to 2
       go top
   seek (wpesq)
   lin = 1
   do while idade = wpesq .and. .not. eof()
      @ lin,01 say nome
      @ lin,25 say dtnasc
      @ lin,37 say idade     pict "99"                    
      lin = lin + 1
      skip
   enddo

elseif wbanco = "ADO"
	****************** ADO / HARBOUR *************** 
   *wsql = "SELECT * FROM cadastro WHERE IDADE = " + NumericSql(wpesq)
   *oConexao:Execute( wsql )

   *como criar o loop de exibicao ?

elseif wbanco = "SQLMIX"
	*************** SQLMIX / HARBOUR *************** 
	* mesmos exemplos do ADO

endif

@ 16,10 say "Final do programa"

return nil

	*************************************************** ABERTURA
   STATIC FUNCTION ConfiguraConexao()
		@ 10,40 say "Inicio da Configuracao da Conexao"
      oConexao := win_OleCreateObject( "ADODB.Connection" )
      oConexao:ConnectionString  := "Driver={MySQL ODBC 3.51 Driver};Server=MeuServidor" + ;
                                    ";Port=3306;Option=131072;Stmt=;Database=MeuBD;User ID=MeuUsuario;Password=MinhaSenha;Collation=latin1;"
      oConexao:CursorLocation    :=   3 // local recordset
      oConexao:CommandTimeOut    := 120 // seconds
      oConexao:ConnectionTimeOut := 120 // seconds
		@ 11,40 say "Final  da Configuracao da Conexao"
   RETURN NIL

**************************************************** FUNCAO PARA FORMATACAO CAMPOS PARA SQL
FUNCTION StringSql( cCampo )
   cCampo1 = chr(34) + cCampo + chr(34)
RETURN cCampo1

FUNCTION NumericSql( nCampo )
RETURN ltrim(str(nCampo))
